# Copyright 2016-2018 Lauri Himanen, Fawzi Mohamed
# 
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.

LIB_XC_MAPPING = {
    "001": "LDA_X",
    "002": "LDA_C_WIGNER",
    "003": "LDA_C_RPA",
    "004": "LDA_C_HL",
    "005": "LDA_C_GL",
    "006": "LDA_C_XALPHA",
    "007": "LDA_C_VWN",
    "008": "LDA_C_VWN_RPA",
    "009": "LDA_C_PZ",
    "010": "LDA_C_PZ_MOD",
    "011": "LDA_C_OB_PZ",
    "012": "LDA_C_PW",
    "013": "LDA_C_PW_MOD",
    "014": "LDA_C_OB_PW",
    "015": "LDA_C_2D_AMGB",
    "016": "LDA_C_2D_PRM",
    "017": "LDA_C_vBH",
    "018": "LDA_C_1D_CSC",
    "019": "LDA_X_2D",
    "020": "LDA_XC_TETER93",
    "021": "LDA_X_1D",
    "101": "GGA_X_PBE",
    "102": "GGA_X_PBE_R",
    "103": "GGA_X_B86",
    "104": "GGA_X_B86_R",
    "105": "GGA_X_B86_MGC",
    "106": "GGA_X_B88",
    "107": "GGA_X_G96",
    "108": "GGA_X_PW86",
    "109": "GGA_X_PW91",
    "110": "GGA_X_OPTX",
    "111": "GGA_X_DK87_R1",
    "112": "GGA_X_DK87_R2",
    "113": "GGA_X_LG93",
    "114": "GGA_X_FT97_A",
    "115": "GGA_X_FT97_B",
    "116": "GGA_X_PBE_SOL",
    "117": "GGA_X_RPBE",
    "118": "GGA_X_WC",
    "119": "GGA_X_mPW91",
    "120": "GGA_X_AM05",
    "121": "GGA_X_PBEA",
    "122": "GGA_X_MPBE",
    "123": "GGA_X_XPBE",
    "124": "GGA_X_2D_B86_MGC",
    "125": "GGA_X_BAYESIAN",
    "126": "GGA_X_PBE_JSJR",
    "127": "GGA_X_2D_B88",
    "128": "GGA_X_2D_B86",
    "129": "GGA_X_2D_PBE",
    "130": "GGA_C_PBE",
    "131": "GGA_C_LYP",
    "132": "GGA_C_P86",
    "133": "GGA_C_PBE_SOL",
    "134": "GGA_C_PW91",
    "135": "GGA_C_AM05",
    "136": "GGA_C_XPBE",
    "137": "GGA_C_LM",
    "138": "GGA_C_PBE_JRGX",
    "139": "GGA_X_OPTB88_VDW",
    "140": "GGA_X_PBEK1_VDW",
    "141": "GGA_X_OPTPBE_VDW",
    "160": "GGA_XC_LB",
    "161": "GGA_XC_HCTH_93",
    "162": "GGA_XC_HCTH_120",
    "163": "GGA_XC_HCTH_147",
    "164": "GGA_XC_HCTH_407",
    "165": "GGA_XC_EDF1",
    "166": "GGA_XC_XLYP",
    "167": "GGA_XC_B97",
    "168": "GGA_XC_B97_1",
    "169": "GGA_XC_B97_2",
    "170": "GGA_XC_B97_D",
    "171": "GGA_XC_B97_K",
    "172": "GGA_XC_B97_3",
    "173": "GGA_XC_PBE1W",
    "174": "GGA_XC_MPWLYP1W",
    "175": "GGA_XC_PBELYP1W",
    "176": "GGA_XC_SB98_1a",
    "177": "GGA_XC_SB98_1b",
    "178": "GGA_XC_SB98_1c",
    "179": "GGA_XC_SB98_2a",
    "180": "GGA_XC_SB98_2b",
    "181": "GGA_XC_SB98_2c",
    "401": "HYB_GGA_XC_B3PW91",
    "402": "HYB_GGA_XC_B3LYP",
    "403": "HYB_GGA_XC_B3P86",
    "404": "HYB_GGA_XC_O3LYP",
    "405": "HYB_GGA_XC_mPW1K",
    "406": "HYB_GGA_XC_PBEH",
    "407": "HYB_GGA_XC_B97",
    "408": "HYB_GGA_XC_B97_1",
    "410": "HYB_GGA_XC_B97_2",
    "411": "HYB_GGA_XC_X3LYP",
    "412": "HYB_GGA_XC_B1WC",
    "413": "HYB_GGA_XC_B97_K",
    "414": "HYB_GGA_XC_B97_3",
    "415": "HYB_GGA_XC_mPW3PW",
    "416": "HYB_GGA_XC_B1LYP",
    "417": "HYB_GGA_XC_B1PW91",
    "418": "HYB_GGA_XC_mPW1PW",
    "419": "HYB_GGA_XC_mPW3LYP",
    "420": "HYB_GGA_XC_SB98_1a",
    "421": "HYB_GGA_XC_SB98_1b",
    "422": "HYB_GGA_XC_SB98_1c",
    "423": "HYB_GGA_XC_SB98_2a",
    "424": "HYB_GGA_XC_SB98_2b",
    "425": "HYB_GGA_XC_SB98_2c",
    "201": "MGGA_X_LTA",
    "202": "MGGA_X_TPSS",
    "203": "MGGA_X_M06L",
    "204": "MGGA_X_GVT4",
    "205": "MGGA_X_TAU_HCTH",
    "206": "MGGA_X_BR89",
    "207": "MGGA_X_BJ06",
    "208": "MGGA_X_TB09",
    "209": "MGGA_X_RPP09",
    "231": "MGGA_C_TPSS",
    "232": "MGGA_C_VSXC",
    "301": "LCA_OMC",
    "302": "LCA_LCH",
}
